Want to contribute? Great! First, read this page (including the small print at
the end).

* [Before You Contribute](#before-you-contribute)
  * [Code Reviews](#code-reviews)
  * [File Headers](#file-headers)
  * [The Small Print](#the-small-print)
* [Large Language Models](#large-language-models)

## Before You Contribute

Before we can use your code, you must sign the
[Google Individual Contributor License Agreement](https://cla.developers.google.com/about/google-individual)
(CLA), which you can do online. The CLA is necessary mainly because you own the
copyright to your changes, even after your contribution becomes part of our
codebase, so we need your permission to use and distribute your code. We also
need to be sure of various other things—for instance that you'll tell us if you
know that your code infringes on other people's patents. You don't have to sign
the CLA until after you've submitted your code for review and a member has
approved it, but you must do it before we can put your code into our codebase.

Before you start working on a larger contribution, you should get in touch with
us first through the issue tracker with your idea so that we can help out and
possibly guide you. Coordinating up front makes it much easier to avoid
frustration later on.

### Code Reviews

All submissions, including submissions by project members, require review.

### File Headers

All files in the project must start with the following header.

    // Copyright 2019 Google LLC
    //
    // Use of this source code is governed by an MIT-style
    // license that can be found in the LICENSE file or at
    // https://opensource.org/licenses/MIT.

### The Small Print

Contributions made by corporations are covered by a different agreement than the
one above, the
[Software Grant and Corporate Contributor License Agreement](https://developers.google.com/open-source/cla/corporate).

## Large Language Models

Do not submit any code or prose written or modified by large language models or
"artificial intelligence" such as GitHub Copilot or ChatGPT to this project.
These tools produce code that looks plausible, which means that not only is it
likely to contain bugs those bugs are likely to be difficult to notice on
review. In addition, because these models were trained indiscriminately and
non-consensually on open-source code with a variety of licenses, it's not
obvious that we have the moral or legal right to redistribute code they
generate.
